#include<iostream>
using namespace std;
int main()
{
	int n,k,a[100][100],br=0;;
	bool t[100],b[100];
	cin>>n>>k;
	for(int i=0;i<k;i++)
	{
		t[i]=false;
		b[i]=false;
	}
	
	for(int i=0;i<n;i++)
	{
		
		for(int j=0;j<n;j++)
		{
			cin>>a[i][j];
		}
	}
	
	for(int i=0;i<n;i++)
	{
	for(int j=0;j<n;j++)
		{
				if(t[a[i][j]]==true)
				{
					if(a[i][j]!=a[i-1][j])
					b[a[i][j]]=true;
				}
				else
				if(a[i][j]!=a[i][j+1])
				t[a[i][j]]=true;
			
		
			
		}
	}
		
		for(int i=0;i<k;i++)
		{
			if(t[i]==true&&b[i]==false)
			br++;
		}
		cout<<br;
		return 0;
}